<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Chat wall</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-T3c6CoIi6uLrA9TneNEoa7RxnatzjcDSCmG1MXxSR1GAsXEV/Dwwykc2MPK8M2HN" crossorigin="anonymous">

    <script>
        function sendMessage() {
            username = document.getElementById("username").value;
            message = document.getElementById("message").value;
            console.debug(username);
            console.debug(message);
            const xhr = new XMLHttpRequest();
            xhr.open("POST", "/", true);
            xhr.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
            xhr.onreadystatechange = () => {
                if (xhr.readyState === XMLHttpRequest.DONE && xhr.status === 200) {
                    document.getElementById("message").value = "";
                    pollMessages();
                }
            };
            xhr.send(JSON.stringify({username:username,message:message}));
        }

        function pollMessages() {
            const xhr = new XMLHttpRequest();
            xhr.open("GET", "/messages?lastMessageId=" + lastMessageId, true);
            xhr.onreadystatechange = () => {
                if (xhr.readyState === XMLHttpRequest.DONE && xhr.status === 200) {
                    updateMessages(JSON.parse(xhr.response));
                }
            };
            xhr.send();
        }

        function updateMessages(messages) {
            chatHistoryElement = document.getElementById("chatHistory");
            scrolledDown = chatHistoryElement.scrollTop === (chatHistoryElement.scrollHeight - chatHistoryElement.offsetHeight)
            messages.forEach((message) => {
                console.debug(chatHistoryElement.innerHTML);
                chatHistoryElement.innerHTML += `
                <div class="card mb-3" style="max-width: 18rem;">
                    <div class="card-header">${message.username}</div>
                    <div class="card-body">
                        <p class="card-text">${message.message}</p>
                    </div>
                    <div class="card-footer">${message.timestamp}</div>
                </div>
                `;
                lastMessageId ++;
            });
            if(scrolledDown) chatHistoryElement.scrollTo(0, chatHistoryElement.scrollHeight);
        }
    </script>
</head>
<body style="max-width: 1024px; margin: 2em auto">
<h1>Chat wall</h1>
<div id="chatHistory" style="overflow-y: scroll; height:400px;"></div>

<form>
    <div class="input-group mb-3">
        <span class="input-group-text">Your name</span>
        <input type="text" class="form-control" placeholder="Username" aria-label="Username"
               id="username" aria-describedby="basic-addon1">
    </div>
    <div class="input-group mb-3">
        <span class="input-group-text">Your message</span>
        <textarea class="form-control" style="resize: none" id="message"></textarea>
    </div>
    <button type="button" class="btn btn-primary" onclick="sendMessage()">Submit</button>
</form>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-C6RzsynM9kWDrMNeT87bh95OGNyZPhcTNXj1NW7RuBCsyN/o0jlpcV8Qyq46cDfL"
        crossorigin="anonymous"></script>
<script>
    var intervalId = window.setInterval(pollMessages, 3000);
    lastMessageId = 0;

    function submitOnEnter(event) {
        if (event.which === 13) {
            if (!event.repeat) {
                sendMessage();
            }
            event.preventDefault();
        }
    }
    document.getElementById("message").addEventListener("keydown", submitOnEnter);
</script>
</body>
</html>
